"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObservableQueryFor = void 0;
class ObservableQueryFor {
    subscribe(callback, args) {
        let actualRoute = this.route;
        if (args && Object.keys(args).length > 0) {
            actualRoute = this.routeTemplate(args);
        }
        const secure = document.location.protocol.indexOf('https') === 0;
        const url = `${secure ? 'wss' : 'ws'}://${document.location.host}${actualRoute}`;
        const socket = new WebSocket(url);
        socket.onopen = (ev) => {
            console.log(`Connection for '${actualRoute}' established`);
        };
        socket.onerror = (error) => {
            console.log(`Error with connection for '${actualRoute} - ${error}`);
        };
        socket.onmessage = (ev) => {
            callback(JSON.parse(ev.data));
        };
    }
}
exports.ObservableQueryFor = ObservableQueryFor;
//# sourceMappingURL=ObservableQueryFor.js.map